--Run SLH_AR_Config_Lua  	
	SLH_AR_Lua = CreateFrame("Frame", "SLH_AR_Lua")
	SLH_AR_Lua:RegisterEvent("ADDON_LOADED")
	SLH_AR_Lua:HookScript("OnEvent", function (self, event, name, ...)
		if (name ~= "SalensLittleHelper") then return end

		--Theoretically speeds up access to global variables by making them local.  This is supposed to be faster.  I have no proof this is true.	
			local _G_SLH = _G 

		local SLH_PCSV_UnitName = _G_SLH["SLH_PCSV"]["SLH_PCSV_UnitNameGlobal"]
		local AR_Profile = _G_SLH["SLH_PCSV"][SLH_PCSV_UnitName]["Config"]["AR_Profile"]
			
		--Development Mode Boolean (Controls various Overrides, disable to test and distribute.)
			local SLH_AR_DevMode = false
			--[[DevMode]]if SLH_AR_DevMode and name ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("AR_Lua addonName: " .. name) end	
					
		-- Set Variables
			local SLH_AR_SetVars = function (self, event, name, ...)
				-- Test/Create SLH_SV Table		
					if _G_SLH["SLH_SV"] == nil then _G_SLH["SLH_SV"] = {} end			
				-- Test/Create SLH_SV.AR_Profile Table
					if _G_SLH["SLH_SV"][AR_Profile] == nil then _G_SLH["SLH_SV"][AR_Profile] = {}  end	
				-- Test/Create SLH_AR_ Table
					if _G_SLH["SLH_SV"][AR_Profile]["AR"] == nil then _G_SLH["SLH_SV"][AR_Profile]["AR"] = {}  end	
						
				-- Test/Create SLH_AR_ Variables
					if _G_SLH["SLH_SV"][AR_Profile]["AR"]["Enable"] == nil then _G_SLH["SLH_SV"][AR_Profile]["AR"]["Enable"] = "Y" end
					if _G_SLH["SLH_SV"][AR_Profile]["AR"]["PlayerFund"] == nil then _G_SLH["SLH_SV"][AR_Profile]["AR"]["PlayerFund"] = "Y" end
					if _G_SLH["SLH_SV"][AR_Profile]["AR"]["GuildFund"] == nil then _G_SLH["SLH_SV"][AR_Profile]["AR"]["GuildFund"] = "N" end
			end

		--SLH_AR_ Module
			local SLH_AR_Module = function (SLH_AR_Options, event, name, ...)
				if IsAltKeyDown() then return end
				if CanMerchantRepair() 
				then
					local SLH_AR_repairAllCost, 
						SLH_AR_canRepair = GetRepairAllCost()

					if SLH_AR_canRepair
					then
						local Gold_SLH_AR_repairAllCost = math.floor (SLH_AR_repairAllCost/10000)
						local Silver_SLH_AR_repairAllCost = math.floor ((SLH_AR_repairAllCost-(Gold_SLH_AR_repairAllCost*10000))/100)
						local Copper_SLH_AR_repairAllCost = (SLH_AR_repairAllCost-(Gold_SLH_AR_repairAllCost*10000)-(Silver_SLH_AR_repairAllCost*100))
						
						local GSC_SLH_AR_repairAllCost = Gold_SLH_AR_repairAllCost .. " Gold, " .. Silver_SLH_AR_repairAllCost .. " Silver, " .. Copper_SLH_AR_repairAllCost .. " Copper"
						
						local GSC_Icons_SLH_AR_repairAllCost = GetCoinTextureString(SLH_AR_repairAllCost)
						
						--RepairAllItems([guildBankRepair]) --guildBankRepair - Flag (Optional) - If 1, use guild funds to repair. If 0, nil, or missing, use player fund
						if CanGuildBankRepair() and _G_SLH["SLH_SV"][AR_Profile]["AR"]["GuildFund"] == "Y"
						then securecall(RepairAllItems,1)
							if GSC_Icons_SLH_AR_repairAllCost ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("Repaired Using Guild Bank Funds: " .. GSC_Icons_SLH_AR_repairAllCost) end		
						elseif _G_SLH["SLH_SV"][AR_Profile]["AR"]["PlayerFund"] == "Y"
						then securecall(RepairAllItems)
							if GSC_Icons_SLH_AR_repairAllCost ~= nil then _G_SLH["SLH_SF"]["Config"]["Print"]("Repaired Using Player Funds: " .. GSC_Icons_SLH_AR_repairAllCost) end
						end
					end
				end		
			end

		--SLH_AR_ EventCall
			local SLH_AR_Events = function (SLH_AR_Options, event, name, ...)
				--Create SLH_AR_ EventFrame
					SLH_AR_EventFrame = CreateFrame("Frame","SLH_AR_EventFrame")

				-- Register SLH_AR_ events
					--Movement
						SLH_AR_EventFrame:RegisterEvent("MERCHANT_SHOW")

				--Call SLH_AR_ HookScript
					if _G_SLH["SLH_SV"][AR_Profile]["AR"]["Enable"] == "Y"
						then SLH_AR_EventFrame:HookScript("OnEvent", SLH_AR_Module)
					end
			end

		--SLH_AR_ Config Screen
			local SLH_AR_Frames= function  (self, event, name, ...)

				-- SLH_AR_ Options
						SLH_AR_Options = CreateFrame( "Frame", "SLH_AR_Options")
						SLH_AR_Options.name = "Auto Repair"
						-- Specify childness of this panel (this puts it under the little red [+], instead of giving it a normal AddOn category)
							SLH_AR_Options.parent = SLH_Config_Panel.name
						-- Add the child to the Interface Options
							InterfaceOptions_AddCategory(SLH_AR_Options)
						--Add Title
							local SLH_AR_OptionsTitle = SLH_AR_Options:CreateFontString(nil, "ARTWORK","GameFontNormalLarge")
							SLH_AR_OptionsTitle:SetPoint("TOPLEFT", 10, -10)
							SLH_AR_OptionsTitle:SetText("Salen's Little Helper - Auto Repair Options")			
					
				--SLH_AR_Detail - Create Scroll Frame		
					SLH_AR_Detail = securecall(_G_SLH["SLH_SF"]["SLH_CreateScrollFrame"],SLH_AR_Options, --self
						"SLH_AR_Detail", --FrameName
						SLH_AR_Options, --relativeFrame
						5, --Offset
						-30, --yOffset
						SLH_AR_Options, --relativeFrame
						-5, --xOffset
						5,--yOffset
						"Auto Repair Options" -- Title
						)
					SLH_AR_Detail.parent = SLH_AR_Options
					
					SLH_AR_Detail.ScrollBar:ClearAllPoints()
					SLH_AR_Detail.ScrollBar:SetPoint("TOPLEFT", SLH_AR_Detail, "TOPRIGHT", -25, -20)
					SLH_AR_Detail.ScrollBar:SetPoint("BOTTOMRIGHT", SLH_AR_Detail, "BOTTOMRIGHT", -5, 25)
					SLH_AR_Detail:SetClipsChildren(true)		
					
					--(Uncomment to) Set Background Color
						--SLH_AR_Detail.bg = SLH_AR_Detail:CreateTexture(nil, "BACKGROUND")
						--SLH_AR_Detail.bg:SetAllPoints(true)
						--SLH_AR_Detail.bg:SetColorTexture(0.8, 0.4, 0, 0.2)
					--End Set Background Color

					--SLH_AR_DetailScrollFrameChild
						local SLH_AR_DetailScrollFrameChild = CreateFrame("Frame", nil, SLH_AR_Detail)
						SLH_AR_DetailScrollFrameChild:SetSize(600, 470)
							--(Uncomment to) Set Background Color
								--SLH_AR_DetailScrollFrameChild.bg = SLH_AR_DetailScrollFrameChild:CreateTexture(nil, "BACKGROUND")
								--SLH_AR_DetailScrollFrameChild.bg:SetAllPoints(true)
								--SLH_AR_DetailScrollFrameChild.bg:SetColorTexture(0.2, 0.6, 0, 0.8)
							--End Set Background Color
						SLH_AR_Detail:SetScrollChild(SLH_AR_DetailScrollFrameChild)	
						SLH_AR_DetailScrollFrameChild:SetClipsChildren(true)		
			
					

					--SLH_AR_Detail Title 
						SLH_AR_DetailScrollFrameChild.title = SLH_AR_DetailScrollFrameChild:CreateFontString (nil, "OVERLAY")
						SLH_AR_DetailScrollFrameChild.title:SetFontObject("GameFontHighlight")
						SLH_AR_DetailScrollFrameChild.title:SetPoint("LEFT", SLH_AR_DetailScrollFrameChild.TitleBg, "LEFT", 5, 0)
						SLH_AR_DetailScrollFrameChild.title:SetText("Auto Repair Options")	
						SLH_AR_DetailScrollFrameChild.title:SetTextColor(_G_SLH["SLH_SF"]["SLH_TitleColors"].r, _G_SLH["SLH_SF"]["SLH_TitleColors"].g, _G_SLH["SLH_SF"]["SLH_TitleColors"].b, _G_SLH["SLH_SF"]["SLH_TitleColors"].a)					

					--MasterFrame.SLH_AR_Detail Buttons
						-- Enable_SLH_AR_ Check Button:
							Enable_SLH_AR_ = securecall(_G_SLH["SLH_SF"]["SLH_CreateCheckButton"],SLH_AR_Options, --self
								"TOPLEFT", --point
								SLH_AR_DetailScrollFrameChild, --relativeFrame
								"Enable_SLH_AR_", --FrameName
								"TOPLEFT", --relativePoint
								20, --Width
								20, --Height
								10, --xOffset
								-20, --yOffset
								"SLH_SV", --SVPath0
								AR_Profile, --SVPath1
								"AR", --SVPath2
								"Enable", --SVPath3
								"Enable Auto Repair", --text
								"Enables Auto Repairing on Vendor Dilaog Open\n\nHolding Alt key disables Auto Repair on the fly" --tooltip
								)
								Enable_SLH_AR_:HookScript("OnClick", function(self, arg1)			
									if Enable_SLH_AR_:GetChecked() 
										then 
											_G_SLH["SLH_SV"][AR_Profile]["AR"]["Enable"] = "Y"
											SLH_AR_SetVars(self, event, name)
											SLH_AR_Events(self, event, name)
										else 
											_G_SLH["SLH_SV"][AR_Profile]["AR"]["Enable"] = "N"
											SLH_AR_EventFrame:UnregisterAllEvents()																		
									end
								end)
								
						-- Enable_SLH_AR_ Check Button:
							SLH_AR_PlayerFund = securecall(_G_SLH["SLH_SF"]["SLH_CreateCheckButton"],SLH_AR_Options, --self
								"TOPLEFT", --point
								Enable_SLH_AR_, --relativeFrame
								"SLH_AR_PlayerFund" , --FrameName
								"TOPLEFT", --relativePoint
								20, --Width
								20, --Height
								0, --xOffset
								-40, --yOffset
								"SLH_SV", --SVPath0
								AR_Profile, --SVPath1
								"AR", --SVPath2
								"PlayerFund", --SVPath3
								"Repair using Player Funds", --text
								"Repair using Player Funds?\n\nYes or No" --tooltip
								)
								
						-- Enable_SLH_AR_ Check Button:
							SLH_AR_GuildFund = securecall(_G_SLH["SLH_SF"]["SLH_CreateCheckButton"],SLH_AR_Options, --self
								"TOPLEFT", --point
								SLH_AR_PlayerFund, --relativeFrame
								"SLH_AR_GuildFund" , --FrameName
								"TOPLEFT", --relativePoint
								20, --Width
								20, --Height
								0, --xOffset
								-20, --yOffset
								"SLH_SV", --SVPath0
								AR_Profile, --SVPath1
								"AR", --SVPath2
								"GuildFund", --SVPath3
								"Repair using Guild Funds", --text
								"Repair using Guild Funds?\n\nYes or No" --tooltip
								)
						
			end

				
			if _G_SLH["SLH_PCSV"][SLH_PCSV_UnitName]["Config"]["AR_Load"] == "Y" then
				SLH_AR_SetVars(self, event, name, ...)
				SLH_AR_Events(self, event, name, ...)
			end
			if _G_SLH["SLH_PCSV"][SLH_PCSV_UnitName]["Config"]["AR_Hide"] == "N" then
				SLH_AR_Frames(self, event, name, ...)
			end
		
	end	)	